--------------------------
--    (c) Copyright IBM Corp. 2009, 2013 All rights reserved.
--   InfoSphere Optim Query Workload Tuner Version 4.1.0.1 for DB2 for Linux, UNIX, and Windows
--    
--	To create the stored procedure that is required for index recommendations, 
--  replace $install with the absolute path to \QueryTunerServerConfig\all_features\LUW\IA\luwsp.jar.
--  Then, run the script on the database.
--------------------------


-- -- install Stored Procedure
DROP PROCEDURE OQT.CALLDB2ADVIS;
CALL SQLJ.REMOVE_JAR ('OQT.CALLDB2ADVIS');
CALL SQLJ.REFRESH_CLASSES();

CALL SQLJ.INSTALL_JAR('file:&install\QueryTunerServerConfig\all_features\LUW\IA\luwsp.jar', 'OQT.CALLDB2ADVIS');
CALL SQLJ.REFRESH_CLASSES();

-- -- create stored procedure for Index Advisor for IBM InfoSphere Optim Query Workload Tuner Version 4.1.0.1
CREATE PROCEDURE OQT.CALLDB2ADVIS ( INOUT major_version INTEGER,
                                INOUT minor_version INTEGER,
                                IN requested_locale VARCHAR(33),
                                IN xml_input BLOB(32M),
                                IN xml_filter BLOB(4K),
                                OUT xml_output BLOB(4K),
                                OUT xml_message BLOB(64K) )
	DYNAMIC RESULT SETS 3
	NOT DETERMINISTIC
	LANGUAGE Java
	EXTERNAL NAME 'OQT.CALLDB2ADVIS:com.ibm.datatools.dsoe.ia.luw.CALLDB2ADVIS.cALLDB2ADVIS'
	FENCED
	THREADSAFE
	PARAMETER STYLE JAVA;
		
-- -- grant the execution privilege to public	
GRANT EXECUTE ON PROCEDURE OQT.CALLDB2ADVIS TO PUBLIC;
