--------------------------
--    (c) Copyright IBM Corp. 2011, 2013 All rights reserved.
--    InfoSphere Optim Query Workload Tuner Version 4.1.0.1 for DB2 for Linux, UNIX, and Windows
--    
--	To create the stored procedure that is required for query-workload tuning, 
--  replace $install with the absolute path to \QueryTunerServerConfig\all_features\LUW\WCC\wccexplainsp.jar.
--  Then, run the script on the database.
--------------------------

DROP PROCEDURE OQT.WCC_EXPLAIN_SP;

CALL SQLJ.REMOVE_JAR('OQT.WCC_EXPLAIN_SP');
CALL SQLJ.REFRESH_CLASSES();

CALL SQLJ.INSTALL_JAR('file:&install\QueryTunerServerConfig\all_features\LUW\WCC\wccexplainsp.jar','OQT.WCC_EXPLAIN_SP');
							  
CALL SQLJ.REFRESH_CLASSES();

CREATE PROCEDURE OQT.WCC_EXPLAIN_SP 
(INOUT major_version INTEGER,
 INOUT minor_version INTEGER,
 IN requested_locale VARCHAR(33),
 IN xml_input BLOB(32M),
 OUT xml_output BLOB(4K),
 OUT xml_message BLOB(64K))
SPECIFIC INSERT
DYNAMIC RESULT SETS 1
DETERMINISTIC
LANGUAGE JAVA
PARAMETER STYLE JAVA
NO DBINFO
FENCED
THREADSAFE
MODIFIES SQL DATA
PROGRAM TYPE SUB
EXTERNAL NAME 'OQT.WCC_EXPLAIN_SP:com.ibm.datatools.dsoe.wcc.luw.sp.WCC_EXPLAIN_SP.wCC_EXPLAIN_SP'
;

commit;

GRANT EXECUTE ON PROCEDURE OQT.WCC_EXPLAIN_SP TO PUBLIC;

