@echo off
# ------------------------------------
#   (c) Copyright IBM Corp. 2009, 2013 All rights reserved.    
#   IBM InfoSphere Optim Query Workload Tuner Version 4.1.0.1 for DB2 for Linux, UNIX, and Windows
# 
#  1. Run the file EXPLAIN.DDL on the database that you want to use for tuning SQL. This file is located in your DB2 installation.
#  2. Run the file License.sh in the directory ./License/License.sh to apply the product license on the database.
#  3. Edit the installation directory in file ./IA/luwsp.sql according to instructions in the file.
#     If the connected database is V9.7.5 or later, comment out line "db2 -tvf ./IA/luwsp.sql > luwsp.out"
#  4. Edit the installation directory in the file ./WCC/wccexplainsp.sql 
#     according to the instructions in the file.
#  6. Replace &database, &user, and &password with your own corresponding values.
#  7. Run this script.
#  6. Check these output files in the current directory for errors: luwsp.out, oqt_profile.out, wccexplainsp.out, and wccluwddl.out
#  7. Ensure there is at least one system temporary table space with the page size 8 KB or larger in the database. 
#  
# -------------------------------------

echo "..............................................."
echo "Creating objects and enabling features..."
echo "..............................................."

db2 connect to &database user &user using &password

echo "Enabling the stored procedure for index recommendations..."
db2 -tvf ./IA/luwsp.sql > luwsp.out

echo "Enabling the functions for creating, validating, and deploying optimization profiles..."
db2 -tvf ./VPH/OPT_PROFILE.ddl > oqt_profile.out

if [ -d ./WCC ]; then
    echo "Creating objects for query-workload tuning..."
	db2 -tvf ./WCC/WCCLUW.ddl  > wccluwddl.out
	db2 -tvf ./WCC/wccexplainsp.sql > wccexplainsp.out	
fi
