@echo off
REM ------------------------
REM    (c) Copyright IBM Corp. 2009, 2013 All rights reserved.
REM    IBM InfoSphere Optim Query Workload Tuner Version 4.1.0.1 for DB2 for Linux, UNIX, and Windows
REM 
REM  1. Run the file EXPLAIN.DDL on the database that you want to use for tuning SQL. This file is located in your DB2 installation.
REM  2. Run the file License.bat in the directory .\License\License.bat to apply the product license on the database.
REM  3. Edit the installation directory in the file .\IA\luwsp.sql according to instructions in the file. 
REM     If the connected database is V9.7.5 or later, comment out section :ENABLE_IA below
REM  4. Edit the installation directory in the file .\WCC\wccexplainsp.sql 
REM     according to the instructions in the file.
REM  5. Open an DB2 Command Line Processor, connect to the database that you activated the license on, and run this file.
REM  6. Check these output files in the current directory for errors: luwsp.out, oqt_profile.out, wccexplainsp.out, and wccluwddl.out
REM  7. Ensure there is at least one system temporary table space with the page size 8 KB or larger in the database. 
REM  
REM -------------------------------------

ECHO ...............................................
ECHO Creating objects and enabling features...
ECHO ...............................................

:ENABLE_IA
ECHO Enabling the stored procedure for index recommendations...
db2 -tvf .\IA\luwsp.sql > luwsp.out

:: enable VPH
ECHO Enabling the functions for creating, validating, and deploying optimization profiles...
IF EXIST .\VPH\OPT_PROFILE.ddl GOTO ENABLE_VPH
ECHO Can't find file .\VPH\OPT_PROFILE.ddl
GOTO ERROR

:ENABLE_VPH 
db2 -tvf .\VPH\OPT_PROFILE.ddl > opt_profile.out

:: enable WCC if workload license
ECHO Enabling query-workload tuning...
IF EXIST .\WCC\ GOTO ENABLE_WCC
GOTO FINISH

:ENABLE_WCC
IF EXIST .\WCC\WCCLUW.ddl GOTO CREATE_WCC
ECHO Can't find file .\WCC\WCCLUW.ddl
GOTO ERROR

:CREATE_WCC
db2 -tvf .\WCC\WCCLUW.ddl > wccluwddl.out
IF EXIST .\WCC\wccexplainsp.sql GOTO WCCSP
ECHO Can't find file .\WCC\wccexplainsp.sql
GOTO ERROR

:WCCSP
IF EXIST .\WCC\wccexplainsp.jar GOTO CREATE_WCCSP
ECHO Can't find file .\WCC\wccexplainsp.jar
GOTO ERROR

:CREATE_WCCSP
ECHO Creating the EXPLAIN stored procedure for query workloads...
db2 -tvf .\WCC\wccexplainsp.sql > wccexplainsp.out
GOTO FINISH

:ERROR
:FINISH


