-- ---------------------------------------------------------------------
--    (c) Copyright IBM Corp. 2010, 2013 All rights reserved.
--    InfoSphere Optim Query Workload Tuner Version 4.1.0.1 for DB2 for Linux, UNIX, and Windows
--    
--    Follow these instructions to migrate EXPLAIN tables that you want to use with IBM InfoSphere Optim Query Workload Tuner v4.1.0 for DB2 for Linux, UNIX, and Windows.
--    1. Replace the keyword $SCHEMA with the schema of the table that you alter or create. 
--    2. Uncomment the statements for the migration path that you select, according to the following table:
--
--                                   		          Database version
--                     	       9.5					        9.7.0					   9.7.1+                           9.8.0/1							9.8.2+						10.1						10.5
--            -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--     	      9.1  	| MIGRATE FROM 9.1 TO 9.5  |  MIGRATE FROM 9.1 TO 9.5   |  MIGRATE FROM 9.1 TO 9.5     |  MIGRATE FROM 9.1 TO 9.5    |	MIGRATE FROM 9.1 TO 9.5		|	MIGRATE FROM 9.1 TO 9.5 	|	MIGRATE FROM 9.1 TO 9.5
--				   	|                          |  MIGRATE FROM 9.5 TO 9.7.0 |  MIGRATE FROM 9.5 TO 9.7.0   |  MIGRATE FROM 9.5 TO 9.7.0  |	MIGRATE FROM 9.5 TO 9.7.0   |	MIGRATE FROM 9.5 TO 9.7.0 	|	MIGRATE FROM 9.5 TO 9.7.0
--                 	|                          |                            |  MIGRATE FROM 9.7.0 TO 9.7.1 |  							 |	MIGRATE FROM 9.7.0 TO 9.7.1 |   MIGRATE FROM 9.7.0 TO 9.7.1	|	MIGRATE FROM 9.7.0 TO 9.7.1
--                 	|                          |                            |                              |  							 |								|	MIGRATE FROM 9.7.1 TO 10.1	|	MIGRATE FROM 9.7.1 TO 10.1
--        			|						   |							|							   |							 |								|								|	MIGRATE FROM 10.1 TO 10.5
--  EXPLAIN   -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--  tables    9.5  	|         n/a              |  MIGRATE FROM 9.5 TO 9.7.0 |  MIGRATE FROM 9.5 TO 9.7.0   |  MIGRATE FROM 9.5 TO 9.7.0  |	MIGRATE FROM 9.5 TO 9.7.0 	|	MIGRATE FROM 9.5 TO 9.7.0 	|	MIGRATE FROM 9.5 TO 9.7.0
-- 	version        	|                          |                            |  MIGRATE FROM 9.7.0 TO 9.7.1 |  							 |	MIGRATE FROM 9.7.0 TO 9.7.1	|	MIGRATE FROM 9.7.0 TO 9.7.1 |	MIGRATE FROM 9.7.0 TO 9.7.1
--                 	|                          |                            |                              |  							 |								|	MIGRATE FROM 9.7.1 TO 10.1	|	MIGRATE FROM 9.7.1 TO 10.1
--					|						   |							|							   |						     |							 	|								|	MIGRATE FROM 10.1 TO 10.5
--            -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--            9.7.0	|         n/a              |           n/a              |  MIGRATE FROM 9.7.0 TO 9.7.1 |  			n/a 			 |	MIGRATE FROM 9.7.0 TO 9.7.1	|	MIGRATE FROM 9.7.0 TO 9.7.1	|	MIGRATE FROM 9.7.0 TO 9.7.1
--                 	|                          |                            |                              |  							 |								|	MIGRATE FROM 9.7.1 TO 10.1	|	MIGRATE FROM 9.7.1 TO 10.1
--					|						   |							|							   |							 |								|								|	MIGRATE FROM 10.1 TO 10.5
--            -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--            9.7.1+|         n/a              |           n/a              |             n/a              |  			n/a  			 |				n/a				|	MIGRATE FROM 9.7.1 TO 10.1	|	MIGRATE FROM 9.7.1 TO 10.1
--					|						   |							|							   |							 |								|								|	MIGRATE FROM 10.1 TO 10.5				
--            -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--           9.8.0/1|         n/a			   |		   n/a				|			  n/a              |            n/a              |  MIGRATE FROM 9.7.0 TO 9.7.1	|	MIGRATE FROM 9.7.0 TO 9.7.1 |	MIGRATE FROM 9.7.0 TO 9.7.1
--                  |                          |							|							   |							 |								|	MIGRATE FROM 9.7.1 TO 10.1  |   MIGRATE FROM 9.7.1 TO 10.1   
--					|						   |							|							   |							 |								|								|	MIGRATE FROM 10.1 TO 10.5						  
--	          -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--           9.8.2+	|		  n/a			   |		   n/a				|			  n/a              |            n/a              |				n/a				|	MIGRATE FROM 9.7.1 TO 10.1	|	MIGRATE FROM 9.7.1 TO 10.1
--					|						   |							|							   |							 |								|								|	MIGRATE FROM 10.1 TO 10.5
--			  -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--			 10.1   |		  n/a			   |		   n/a         		|			  n/a              |            n/a              |              n/a             |              n/a              |	MIGRATE FROM 10.1 TO 10.5
--			  -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--		 Note: Explain tables in V9.7.0 are the same as in V9.8.0 and V9.8.1, and those in V9.7.1+ are the same as in V9.8.2+. Therefore, the table above shows reusing the migration DDL statements of V9.7.x for V9.8.x. 
--
--    3. Connect to the DB2 database where the EXPLAIN tables are located.
--    4. Run this ddl file with the following command: 
--			db2 -tf migrate_explaintables_db2luw.ddl
--    5. Run the REORG utility on the table that you altered.

SET CURRENT SCHEMA = '$SCHEMA';

-- MIGRATE FROM 9.1 TO 9.5 --
-- 		ALTER TABLE ADVISE_INDEX ALTER COLUMN NLEAF SET DATA TYPE BIGINT;
-- 		ALTER TABLE ADVISE_INDEX ALTER COLUMN SEQUENTIAL_PAGES SET DATA TYPE BIGINT;

-- MIGRATE FROM 9.5 TO 9.7.0 --
-- 		ALTER TABLE ADVISE_INDEX ALTER COLUMN COLNAMES SET WITH DEFAULT;

-- MIGRATE FROM 9.7.0 TO 9.7.1 --
-- 		DROP INDEX OPR_I1;
--		COMMIT;
-- 		ALTER TABLE EXPLAIN_OPERATOR ADD PRIMARY KEY 
--   		(EXPLAIN_REQUESTER, EXPLAIN_TIME, SOURCE_NAME, SOURCE_SCHEMA, SOURCE_VERSION, EXPLAIN_LEVEL, STMTNO, SECTNO, OPERATOR_ID);

-- 		CREATE TABLE EXPLAIN_ACTUALS ( EXPLAIN_REQUESTER VARCHAR(128) NOT NULL,
--                                EXPLAIN_TIME      TIMESTAMP    NOT NULL,
--                                SOURCE_NAME       VARCHAR(128) NOT NULL,
--                                SOURCE_SCHEMA     VARCHAR(128) NOT NULL,
--                                SOURCE_VERSION    VARCHAR(64)  NOT NULL,
--                                EXPLAIN_LEVEL     CHAR(1)      NOT NULL,
--                                STMTNO            INTEGER      NOT NULL,
--                                SECTNO            INTEGER      NOT NULL,
--                                OPERATOR_ID       INTEGER      NOT NULL,
--                                DBPARTITIONNUM    INTEGER      NOT NULL,
--                                PREDICATE_ID      INTEGER,
--                                HOW_APPLIED       CHAR(10),
--                                ACTUAL_TYPE       VARCHAR(12)  NOT NULL,
--                                ACTUAL_VALUE      DOUBLE,
--                                   FOREIGN KEY (EXPLAIN_REQUESTER,
--                                                EXPLAIN_TIME,
--                                                SOURCE_NAME,
--                                                SOURCE_SCHEMA,
--                                                SOURCE_VERSION,
--                                                EXPLAIN_LEVEL,
--                                                STMTNO,
--                                                SECTNO,
--                                                OPERATOR_ID)
--                                   REFERENCES EXPLAIN_OPERATOR
--                                   ON DELETE CASCADE);
-- 		COMMIT;
--      Optionally grant privileges on table "EXPLAIN_ACTUALS" to users/groups that you allow to access this table.  

-- MIGRATE FROM 9.7.1 TO 10.1 --
-- ALTER TABLE EXPLAIN_INSTANCE ADD COLUMN EXECUTABLE_ID VARCHAR(32) FOR BIT DATA ADD COLUMN EXECUTION_TIME TIMESTAMP;
-- ALTER TABLE EXPLAIN_PREDICATE ADD COLUMN INDEX_COLSEQ INTEGER NOT NULL DEFAULT -1;
-- ALTER TABLE EXPLAIN_PREDICATE ALTER COLUMN INDEX_COLSEQ DROP DEFAULT;

-- CREATE TABLE OBJECT_METRICS ( EXECUTABLE_ID     VARCHAR(32) FOR BIT DATA NOT NULL,
--                               EXECUTION_TIME    TIMESTAMP    NOT NULL,
--                               OBJECT_SCHEMA     VARCHAR(128) NOT NULL,
--                               OBJECT_NAME       VARCHAR(128) NOT NULL,
--                               OBJECT_TYPE       CHAR(2)      NOT NULL,
--                               MEMBER            SMALLINT     NOT NULL, 
--                               DATA_PARTITION_ID INTEGER      NOT NULL,
--                               ROWS_INSERTED                             BIGINT, 
--                               ROWS_DELETED                              BIGINT, 
--                               ROWS_UPDATED                              BIGINT, 
--                               ROWS_READ                                 BIGINT, 
--                               OVERFLOW_CREATES                          BIGINT, 
--                               OVERFLOW_ACCESSES                         BIGINT, 
--                               LOCK_WAIT_TIME                            BIGINT, 
--                               LOCK_WAIT_TIME_GLOBAL                     BIGINT, 
--                               LOCK_WAITS                                BIGINT, 
--                               LOCK_WAITS_GLOBAL                         BIGINT, 
--                               LOCK_ESCALS                               BIGINT, 
--                               LOCK_ESCALS_GLOBAL                        BIGINT, 
--                               DIRECT_WRITES                             BIGINT, 
--                               DIRECT_WRITE_REQS                         BIGINT, 
--                               DIRECT_READS                              BIGINT, 
--                               DIRECT_READ_REQS                          BIGINT, 
--                               OBJECT_DATA_L_READS                       BIGINT, 
--                               OBJECT_DATA_P_READS                       BIGINT, 
--                               OBJECT_DATA_GBP_L_READS                   BIGINT, 
--                               OBJECT_DATA_GBP_P_READS                   BIGINT, 
--                               OBJECT_DATA_GBP_INVALID_PAGES             BIGINT, 
--                               OBJECT_DATA_LBP_PAGES_FOUND               BIGINT, 
--                               OBJECT_DATA_GBP_INDEP_PAGES_FOUND_IN_LBP  BIGINT,
--                               OBJECT_XDA_L_READS                        BIGINT, 
--                               OBJECT_XDA_P_READS                        BIGINT, 
--                               OBJECT_XDA_GBP_L_READS                    BIGINT, 
--                               OBJECT_XDA_GBP_P_READS                    BIGINT, 
--                               OBJECT_XDA_GBP_INVALID_PAGES              BIGINT, 
--                               OBJECT_XDA_LBP_PAGES_FOUND                BIGINT,
--                               OBJECT_XDA_GBP_INDEP_PAGES_FOUND_IN_LBP   BIGINT,
--                               OBJECT_INDEX_L_READS                      BIGINT, 
--                               OBJECT_INDEX_P_READS                      BIGINT, 
--                               OBJECT_INDEX_GBP_L_READS                  BIGINT, 
--                               OBJECT_INDEX_GBP_P_READS                  BIGINT, 
--                               OBJECT_INDEX_GBP_INVALID_PAGES            BIGINT, 
--                               OBJECT_INDEX_LBP_PAGES_FOUND              BIGINT, 
--                               OBJECT_INDEX_GBP_INDEP_PAGES_FOUND_IN_LBP BIGINT,
--                                       PRIMARY KEY (EXECUTABLE_ID,
--                                                    EXECUTION_TIME,
--                                                    OBJECT_SCHEMA,
--                                                    OBJECT_NAME,
--                                                    OBJECT_TYPE,
--                                                    MEMBER,
--                                                    DATA_PARTITION_ID));
--
--      Optionally grant privileges on table "OBJECT_METRICS" to users/groups that you allow to access this table.  

-- MIGRATE FROM 10.1 TO 10.5 --
-- ALTER TABLE SYSTOOLS.OBJECT_METRICS ADD COLUMN OBJECT_COL_L_READS BIGINT ADD COLUMN OBJECT_COL_P_READS BIGINT ADD COLUMN OBJECT_COL_GBP_L_READS BIGINT ADD COLUMN OBJECT_COL_GBP_P_READS BIGINT ADD COLUMN OBJECT_COL_GBP_INVALID_PAGES BIGINT ADD COLUMN OBJECT_COL_LBP_PAGES_FOUND BIGINT ADD COLUMN OBJECT_COL_GBP_INDEP_PAGES_FOUND_IN_LBP BIGINT ADD COLUMN OBJECT_DATA_CACHING_TIER_L_READS BIGINT ADD COLUMN OBJECT_DATA_CACHING_TIER_PAGES_FOUND BIGINT ADD COLUMN OBJECT_DATA_CACHING_TIER_GBP_INVALID_PAGES BIGINT ADD COLUMN OBJECT_DATA_CACHING_TIER_GBP_INDEP_PAGES_FOUND BIGINT ADD COLUMN OBJECT_XDA_CACHING_TIER_L_READS BIGINT ADD COLUMN OBJECT_XDA_CACHING_TIER_PAGES_FOUND BIGINT ADD COLUMN OBJECT_XDA_CACHING_TIER_GBP_INVALID_PAGES BIGINT ADD COLUMN OBJECT_XDA_CACHING_TIER_GBP_INDEP_PAGES_FOUND BIGINT ADD COLUMN OBJECT_INDEX_CACHING_TIER_L_READS BIGINT ADD COLUMN OBJECT_INDEX_CACHING_TIER_PAGES_FOUND BIGINT ADD COLUMN OBJECT_INDEX_CACHING_TIER_GBP_INVALID_PAGES BIGINT ADD COLUMN OBJECT_INDEX_CACHING_TIER_GBP_INDEP_PAGES_FOUND BIGINT ADD COLUMN OBJECT_COL_CACHING_TIER_L_READS BIGINT ADD COLUMN OBJECT_COL_CACHING_TIER_PAGES_FOUND BIGINT ADD COLUMN OBJECT_COL_CACHING_TIER_GBP_INVALID_PAGES BIGINT ADD COLUMN OBJECT_COL_CACHING_TIER_GBP_INDEP_PAGES_FOUND BIGINT;
-- ALTER TABLE SYSTOOLS.ADVISE_INDEX ADD COLUMN NULLKEYS CHAR(1) NOT NULL DEFAULT 'Y';;
-- ALTER TABLE SYSTOOLS.EXPLAIN_OBJECT ADD COLUMN NULLKEYS CHAR(1);
