#If explain tables are not created by OQT, the following indexes 
#are needed to be created to improve the performance of workload 
#capturing from plan/package. Replace "&CREATOR" to the qualifier 
#of the indexes.


CREATE INDEX "&CREATOR"."DSN_DETCOST_TABLE_IDX1"

	ON "&CREATOR"."DSN_DETCOST_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;     


CREATE INDEX "&CREATOR"."DSN_FILTER_TABLE_IDX1"

	ON "&CREATOR"."DSN_FILTER_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;     


CREATE INDEX "&CREATOR"."DSN_FUNCTION_TABLE_IDX1"

	ON "&CREATOR"."DSN_FUNCTION_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;     


CREATE INDEX "&CREATOR"."DSN_PGRANGE_TABLE_IDX1"

	ON "&CREATOR"."DSN_PGRANGE_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;     


CREATE INDEX "&CREATOR"."DSN_PGROUP_TABLE_IDX1"

	ON "&CREATOR"."DSN_PGROUP_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;     


CREATE INDEX "&CREATOR"."DSN_PREDICAT_TABLE_IDX1"

	ON "&CREATOR"."DSN_PREDICAT_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;     


CREATE INDEX "&CREATOR"."DSN_PTASK_TABLE_IDX1"

	ON "&CREATOR"."DSN_PTASK_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;     


CREATE INDEX "&CREATOR"."DSN_QUERY_TABLE_IDX1"

	ON "&CREATOR"."DSN_QUERY_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;     


CREATE INDEX "&CREATOR"."DSN_QUERY_TABLE_IDX2"

	ON "&CREATOR"."DSN_QUERY_TABLE"

	("QUERYNO"		ASC,

	  "TYPE"		ASC,

	  "QUERY_STAGE"		ASC,

	  "EXPLAIN_TIME"		ASC,

	  "SEQNO"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;     

CREATE UNIQUE INDEX "&CREATOR"."DSN_QUERY_UNIQIX"

	ON "&CREATOR"."DSN_QUERY_TABLE"

	("QUERY_ROWID"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_SORTKEY_TABLE_IDX1"

	ON "&CREATOR"."DSN_SORTKEY_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_SORT_TABLE_IDX1"

	ON "&CREATOR"."DSN_SORT_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_STATEMENT_CACHE_IDX1"

	ON "&CREATOR"."DSN_STATEMENT_CACHE_TABLE"

	("STMT_ID"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_STATEMENT_CACHE_IDX2"

	ON "&CREATOR"."DSN_STATEMENT_CACHE_TABLE"

	("STMT_TOKEN"		ASC)

	CLUSTER

	NOT PADDED

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_STATEMENT_CACHE_IDX3"

	ON "&CREATOR"."DSN_STATEMENT_CACHE_TABLE"

	("EXPLAIN_TS"		DESC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_STATEMNT_TABLE_IDX1"

	ON "&CREATOR"."DSN_STATEMNT_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_STRUCT_TABLE_IDX1"

	ON "&CREATOR"."DSN_STRUCT_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_VIEWREF_TABLE_IDX1"

	ON "&CREATOR"."DSN_VIEWREF_TABLE"

	("QUERYNO"		ASC,

	  "EXPLAIN_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_VIRTUAL_INDEXES_IDX1"

	ON "&CREATOR"."DSN_VIRTUAL_INDEXES"

	("ENABLE"		ASC,

	  "MODE"		ASC,

	  "TBCREATOR"		ASC,

	  "TBNAME"		ASC,

	  "IXCREATOR"		ASC,

	  "IXNAME"		ASC)

	NOT CLUSTER

	NOT PADDED

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."DSN_VIRTUAL_INDEXES_IDX2"

	ON "&CREATOR"."DSN_VIRTUAL_INDEXES"

	("TBCREATOR"		ASC,

	  "TBNAME"		ASC)

	NOT CLUSTER

	NOT PADDED

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;

CREATE INDEX "&CREATOR"."PLAN_TABLE_IDX1"

	ON "&CREATOR"."PLAN_TABLE"

	("QUERYNO"		ASC,

	  "BIND_TIME"		ASC)

	NOT CLUSTER

	BUFFERPOOL BP0

  USING STOGROUP SYSDEFLT;
